#include <tiny13a.h>
#include <delay.h>

volatile bit tmp1 = 0, tmp2 = 1, hcf = 0;

void port_init ()
{
PORTB=0x00;
DDRB=0x00;

DDRB.3 = 1;
DDRB.4 = 1;
PORTB.3 = tmp1;
PORTB.4 = tmp2;
}

void t1_init ()
{
TCCR0A=0x00;
TCCR0B=0b00000101; // osc/1024
TCNT0=0xAF;  // for 120Hz
OCR0A=0x00;
OCR0B=0x00;

TIMSK0 |= (1<<TOIE0);
}

void anacomp_init ()
{
ACSR=0b01001010;//bandgap en, ie en on falling edge
ADCSRB=0x00;//adc control & status
//DIDR0=0B00111111; //digital input disable reg
}

void adc_init ()
{
ADMUX |= (1<<REFS0)|(1<<ADLAR)|(1<<MUX0); // internal refs, 8 bit, adc1 
ADCSRA=0b10000001;  // adc enable, div 2
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// #asm ("wdr")
TCNT0=0xAF;
PORTB &= 0; 
#asm ("cli")
#asm ("wdr")
if (hcf == 0) {delay_us (1000);}   
else  {delay_us (6000);}
tmp1 = tmp2; tmp2 = ~tmp2;
PORTB  |= (tmp1<<3)|(tmp2<<4);
#asm("sei")
}

//interrupt [WDT] void wdt_timeout_isr(void)
//{
//#asm ("wdr")
//}

interrupt [ANA_COMP] void ana_comp_isr(void)
{
hcf = 1;
do  //overcurrent protection mode 
   {
    delay_ms (5000);
    PORTB &= ~((1<<3)|(1<<4));
    } while (ACSR.5 == 0);
}

 void check_adc (void) 
{
  unsigned int adcTemp = 0;
  unsigned int adcValue = 0;
  unsigned char count = 0;
  
for (count=0; count < 8; count++) 
{
ADCSRA |= (1<<ADSC);//adc start conversion
while (ADCSRA.6 != 0x00); //wait for conversion complete
   adcTemp = ADCH; //8bit precision
   adcValue = adcValue + adcTemp;
}
    adcValue = (adcValue >> 3); // div by 8 for get average conversion result
   if (adcValue >= 180) hcf = 1;
   else hcf = 0;
}


void main(void)
{
port_init ();
anacomp_init ();
adc_init ();
t1_init ();  

#pragma optsize-
//WDTCR=0b00111001;   //change enable
//WDTCR=0b01101001;  //int enable, system reset enable, 31Hz
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {
       check_adc ();
      }
}
